<ion-content class="ion-padding">
    <form on:submit|preventDefault={createOuting} on:change={validate} on:ionChange={validate}>
        <ion-item>
            <ion-label position="floating">Outing Name{#if invalidFields.name}<span class="failedValidationText">&nbsp;- {invalidFields.name}</span>{/if}</ion-label>
            <ion-input on:keyup={(e) => outing.name = e.currentTarget.value }></ion-input>
        </ion-item>
        <ion-item>
            <ion-label position="floating">Start Date{#if invalidFields.startDate}<span class="failedValidationText">&nbsp;- {invalidFields.startDate}</span>{/if}</ion-label>
            <ion-datetime display-format="YYYY-MM-DD" on:ionChange={(e) => outing.startDate = moment(e.currentTarget.value, 'YYYY-MM-DD').toDate() }></ion-datetime>
        </ion-item>
        <ion-item>
            <ion-label position="floating">End Date{#if invalidFields.endDate}<span class="failedValidationText">&nbsp;- {invalidFields.endDate}</span>{/if}</ion-label>
            <ion-datetime display-format="YYYY-MM-DD" on:ionChange={(e) => outing.endDate = moment(e.currentTarget.value, 'YYYY-MM-DD').toDate()}></ion-datetime>
        </ion-item>
        <ion-button type="submit" expand="block">Create Outing</ion-button>
    </form>
</ion-content>



<script>
import {navigateTo} from 'svelte-grouter'
import * as outingService from '/lib/OutingsService'
import {outingsByUserStore} from '/client/OutingsStore'
import moment from 'moment'
import {layoutStore} from '/client/LayoutStore'
import {currentUserStore} from '/client/UsersStore'

$layoutStore.title = 'Create Outing'
$layoutStore.showBack = true

'Create Outing'
let invalidFields = {}, submitted = false
$: console.log(invalidFields) // logging invalid fields until we figure out ionic form validation
$: user = $currentUserStore
let outing = {}
$: if (user) {
    outing = {
        name: '',
        startDate: '',
        endDate: '',
        host: user._id
    }
}
function createOuting() {
    submitted = true
    if (!validate()) return false
    
    //TODO" need to better handle error if server is unable to create outing. 
    outingService.createOuting(outing)
    .then(outingId => {
        console.log('Created a new outing with id ', outingId)
        if(outingId){
            navigateTo('invite', {id: outingId})
        }
    })
}

function validate() {
    if (submitted) {
        invalidFields = outingService.validate(outing)
        if (Object.keys(invalidFields).length > 0 ) {
            return false
        }
    }
    return true
}


</script>

<style>
ion-button {
    margin-top: 50px;
}
</style>